###################################################
### chunk number 1: 
###################################################
library(pcaMethods)


###################################################
### chunk number 2: 
###################################################
data(metaboliteData)
mD <- metaboliteData
sum(is.na(mD))


###################################################
### chunk number 3: 
###################################################
pc <- pca(mD, nPcs=3, method="ppca")
imputed <- completeObs(pc)


###################################################
### chunk number 4: 
###################################################
data(metaboliteDataComplete)
mdComp <- metaboliteDataComplete
sum((mdComp[is.na(mD)] - imputed[is.na(mD)])^2) / sum(mdComp[is.na(mD)]^2)


###################################################
### chunk number 5: 
###################################################
imputedNipals <- completeObs(pca(mD, nPcs=3, method="nipals"))
sum((mdComp[is.na(mD)] - imputedNipals[is.na(mD)])^2) / sum(mdComp[is.na(mD)]^2)


###################################################
### chunk number 6: 
###################################################
library(Biobase)
data(sample.ExpressionSet)
exSet <- sample.ExpressionSet
exSetNa <- exSet
exprs(exSetNa)[sample(13000, 200)] <- NA
lost <- is.na(exprs(exSetNa))
pc <- pca(exSetNa, nPcs=2, method="ppca")
impExSet <- asExprSet(pc, exSetNa)
sum((exprs(exSet)[lost] - exprs(impExSet)[lost])^2) / sum(exprs(exSet)[lost]^2)


